KDE 4.9 PyKDE API Reference

- KDE's Python API

# Element Class Reference

`from PyKDE4.khtml import *`

Inherits: DOM.Node
Subclasses: DOM.HTMLElement
Namespace: DOM

## Detailed Description

By far the vast majority of objects (apart from text) that authors encounter when traversing a document are Element nodes. Assume the following XML document: &lt;elementExample id=&quot;demo&quot;&gt; &lt;subelement1/&gt; &lt;subelement2&gt;&lt;subsubelement/&gt;&lt;/subelement2&gt; &lt;/elementExample&gt;

When represented using DOM, the top node is an Element node for &quot;elementExample&quot;, which contains two child Element nodes, one for &quot;subelement1&quot; and one for &quot;subelement2&quot;. &quot;subelement1&quot; contains no child nodes.

Elements may have attributes associated with them; since the Element interface inherits from Node , the generic Node interface method getAttributes may be used to retrieve the set of all attributes for an element. There are methods on the Element interface to retrieve either an Attr object by name or an attribute value by name. In XML, where an attribute value may contain entity references, an Attr object should be retrieved to examine the possibly fairly complex sub-tree representing the attribute value. On the other hand, in HTML, where all attributes have simple string values, methods to directly access an attribute value can safely be used as a convenience.

## Methods

| __init__ (self)
| __init__ (self, DOM.Node other)
| __init__ (self, DOM.Element other)
long | childElementCount (self)
DOM.Element | firstElementChild (self)
DOM.Element | form (self)
DOM.DOMString | getAttribute (self, DOM.DOMString name)
DOM.DOMString | getAttributeNS (self, DOM.DOMString namespaceURI, DOM.DOMString localName)
DOM.Attr | getAttributeNode (self, DOM.DOMString name)
DOM.Attr | getAttributeNodeNS (self, DOM.DOMString namespaceURI, DOM.DOMString localName)
DOM.NodeList | getElementsByClassName (self, DOM.DOMString className)
DOM.NodeList | getElementsByTagName (self, DOM.DOMString name)
DOM.NodeList | getElementsByTagNameNS (self, DOM.DOMString namespaceURI, DOM.DOMString localName)
bool | hasAttribute (self, DOM.DOMString name)
bool | hasAttributeNS (self, DOM.DOMString namespaceURI, DOM.DOMString localName)
bool | isHTMLElement (self)
DOM.Element | lastElementChild (self)
DOM.Element | nextElementSibling (self)
DOM.Element | previousElementSibling (self)
DOM.Element | querySelector (self, DOM.DOMString query)
DOM.NodeList | querySelectorAll (self, DOM.DOMString query)
| removeAttribute (self, DOM.DOMString name)
| removeAttributeNS (self, DOM.DOMString namespaceURI, DOM.DOMString localName)
DOM.Attr | removeAttributeNode (self, DOM.Attr oldAttr)
| setAttribute (self, DOM.DOMString name, DOM.DOMString value)
| setAttributeNS (self, DOM.DOMString namespaceURI, DOM.DOMString qualifiedName, DOM.DOMString value)
DOM.Attr | setAttributeNode (self, DOM.Attr newAttr)
DOM.Attr | setAttributeNodeNS (self, DOM.Attr newAttr)
DOM.CSSStyleDeclaration | style (self)
DOM.DOMString | tagName (self)

## Static Methods

bool | khtmlMalformedPrefix (DOM.DOMString name)
bool | khtmlMalformedQualifiedName (DOM.DOMString name)
bool | khtmlValidAttrName (DOM.DOMString name)
bool | khtmlValidPrefix (DOM.DOMString name)
bool | khtmlValidQualifiedName (DOM.DOMString name)

## Method Documentation

__init__ | ( |  | self ) |

__init__ | ( | self, |
|  | DOM.Node | other
| ) |  |  |

__init__ | ( | self, |
|  | DOM.Element | other
| ) |  |  |

long childElementCount | ( |  | self ) |

Introduced in DOM level 3 This method is part of the ElementTraversal interface

Returns:
  The current number of child nodes of that element which are of nodeType ELEMENT_NODE

DOM.Element firstElementChild | ( |  | self ) |

Introduced in DOM level 3 This method is part of the ElementTraversal interface

The first child node which is of nodeType ELEMENT_NODE.

DOM.Element form | ( |  | self ) |

KHTML extension to DOM This method returns the associated form element. returns null if this element is not a form-like element or if this elment is not in the scope of a form element.

DOM.DOMString getAttribute | ( | self, |
|  | DOM.DOMString | name
| ) |  |  |

Retrieves an attribute value by name.

Parameters:

  | name | The name of the attribute to retrieve.

Returns:
  The Attr value as a string, or the empty string if that attribute does not have a specified or default value.

DOM.DOMString getAttributeNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | localName
| ) |  |  |

Introduced in DOM Level 2.

No Exceptions.

Retrieves an attribute value by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to retrieve.
  | localName | The local name of the attribute to retrieve.

Returns:
  The Attr value as a string, or the empty string if that attribute does not have a specified or default value.

DOM.Attr getAttributeNode | ( | self, |
|  | DOM.DOMString | name
| ) |  |  |

Retrieves an Attr node by name.

Parameters:

  | name | The name of the attribute to retrieve.

Returns:
  The Attr node with the specified attribute name or null if there is no such attribute.

DOM.Attr getAttributeNodeNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | localName
| ) |  |  |

Introduced in DOM Level 2

Retrieves an Attr node by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to retrieve.
  | localName | The local name of the attribute to retrieve.

Returns:
  The Attr node with the specified attribute local name and namespace URI or null if there is no such attribute.

DOM.NodeList getElementsByClassName | ( | self, |
|  | DOM.DOMString | className
| ) |  |  |

Introduced in HTML 5. No Exceptions.

Returns a NodeList of all the Element 's with a given class name in the order in which they would be encountered in a preorder traversal of the Document tree.

Parameters:

  | tagname | An unordered set of unique space-separated tokens representing classes.

Returns:
  A new NodeList object containing all the matched Element s.

Since:
  4.1

DOM.NodeList getElementsByTagName | ( | self, |
|  | DOM.DOMString | name
| ) |  |  |

Returns a NodeList of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the Element tree.

Parameters:

  | name | The name of the tag to match on. The special value "*" matches all tags.

Returns:
  A list of matching Element nodes.

DOM.NodeList getElementsByTagNameNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | localName
| ) |  |  |

Introduced in DOM Level 2 Returns a NodeList of all the descendant Elements with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of this Element tree.

Parameters:

  | namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  | localName | The local name of the elements to match on. The special value "*" matches all local names.

Returns:
  A new NodeList object containing all the matched Elements.

bool hasAttribute | ( | self, |
|  | DOM.DOMString | name
| ) |  |  |

Returns true when an attribute with a given name is specified on this element or has a default value, false otherwise. Introduced in DOM Level 2.

Parameters:

  | name | The name of the attribute to look for.

Returns:
  true if an attribute with the given name is specified on this element or has a default value, false otherwise.

bool hasAttributeNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | localName
| ) |  |  |

Introduced in DOM Level 2

Returns true when an attribute with a given local name and namespace URI is specified on this element or has a default value, false otherwise. HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to look for.
  | localName | The local name of the attribute to look for.

Returns:
  true if an attribute with the given local name and namespace URI is specified or has a default value on this element, false otherwise.

bool isHTMLElement | ( |  | self ) |

Internal:
  not part of the DOM

DOM.Element lastElementChild | ( |  | self ) |

Introduced in DOM level 3 This method is part of the ElementTraversal interface

Returns:
  The last child node of that element which is of nodeType ELEMENT_NODE.

DOM.Element nextElementSibling | ( |  | self ) |

Introduced in DOM level 3 This method is part of the ElementTraversal interface

Returns:
  The sibling node of that element which most immediately follows that element in document order, and which is of nodeType ELEMENT_NODE

DOM.Element previousElementSibling | ( |  | self ) |

Introduced in DOM level 3 This method is part of the ElementTraversal interface

Returns:
  The sibling node of that element which most immediately precedes that element in document order, and which is of nodeType ELEMENT_NODE

DOM.Element querySelector | ( | self, |
|  | DOM.DOMString | query
| ) |  |  |

Introduced in Selectors Level 1.

Returns the first (in document order) element in this element's subtree matching the given CSS selector query.

Since:
  4.5

DOM.NodeList querySelectorAll | ( | self, |
|  | DOM.DOMString | query
| ) |  |  |

Introduced in Selectors Level 1.

Returns all (in document order) elements in this element's subtree matching the given CSS selector query. Note that the returned NodeList is static and not live, and will not be updated when the document changes

Since:
  4.5

removeAttribute | ( | self, |
|  | DOM.DOMString | name
| ) |  |  |

Removes an attribute by name. If the removed attribute has a default value it is immediately replaced.

Parameters:

  | name | The name of the attribute to remove.

Returns:

DOMException NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

removeAttributeNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | localName
| ) |  |  |

Introduced in DOM Level 2

Removes an attribute by local name and namespace URI. If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix.

HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to remove.
  | localName | The local name of the attribute to remove.

DOMException NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

DOM.Attr removeAttributeNode | ( | self, |
|  | DOM.Attr | oldAttr
| ) |  |  |

Removes the specified attribute.

Parameters:

  | oldAttr | The Attr node to remove from the attribute list. If the removed Attr has a default value it is immediately replaced.

Returns:
  The Attr node that was removed.

DOMException NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if oldAttr is not an attribute of the element.

setAttribute | ( | self, |
|  | DOM.DOMString | name,
|  | DOM.DOMString | value
| ) |  |  |

Adds a new attribute. If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an Attr node plus any Text and EntityReference nodes, build the appropriate subtree, and use setAttributeNode to assign it as the value of an attribute.

Parameters:

  | name | The name of the attribute to create or alter.
  | value | Value to set in string form.

Returns:

DOMException INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

setAttributeNS | ( | self, |
|  | DOM.DOMString | namespaceURI,
|  | DOM.DOMString | qualifiedName,
|  | DOM.DOMString | value
| ) |  |  |

Introduced in DOM Level 2

Adds a new attribute. If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the qualifiedName, and its value is changed to be the value parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an Attr node plus any Text and EntityReference nodes, build the appropriate subtree, and use setAttributeNodeNS or setAttributeNode to assign it as the value of an attribute.

HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to create or alter.
  | qualifiedName | The qualified name of the attribute to create or alter.
  | value | The value to set in string form.

DOMException INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NAMESPACE_ERR: Raised if the qualifiedName is malformed, if the qualifiedName has a prefix and the namespaceURI is null, if the qualifiedName has a prefix that is "xml" and the namespaceURI is different from "http://www.w3.org/XML/1998/namespace", or if the qualifiedName is "xmlns" and the namespaceURI is different from "http://www.w3.org/2000/xmlns/".

DOM.Attr setAttributeNode | ( | self, |
|  | DOM.Attr | newAttr
| ) |  |  |

Adds a new attribute. If an attribute with that name is already present in the element, it is replaced by the new one.

Parameters:

  | newAttr | The Attr node to add to the attribute list.

Returns:
  If the newAttr attribute replaces an existing attribute with the same name, the previously existing

Attr node is returned, otherwise null is returned.

DOMException WRONG_DOCUMENT_ERR: Raised if newAttr was created from a different document than the one that created the element.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

INUSE_ATTRIBUTE_ERR: Raised if newAttr is already an attribute of another Element object. The DOM user must explicitly clone Attr nodes to re-use them in other elements.

DOM.Attr setAttributeNodeNS | ( | self, |
|  | DOM.Attr | newAttr
| ) |  |  |

Introduced in DOM Level 2

Adds a new attribute. If an attribute with that local name and that namespace URI is already present in the element, it is replaced by the new one.

HTML-only DOM implementations do not need to implement this method.

Parameters:

  | newAttr | The Attr node to add to the attribute list.

Returns:
  If the newAttr attribute replaces an existing attribute with the same local name and namespace URI, the replaced Attr node is returned, otherwise null is returned.

DOMException WRONG_DOCUMENT_ERR: Raised if newAttr was created from a different document than the one that created the element.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

INUSE_ATTRIBUTE_ERR: Raised if newAttr is already an attribute of another Element object. The DOM user must explicitly clone Attr nodes to re-use them in other elements.

DOM.CSSStyleDeclaration style | ( |  | self ) |

Introduced in DOM Level 2 This method is from the CSSStyleDeclaration interface

The style attribute

DOM.DOMString tagName | ( |  | self ) |

The name of the element. For example, in: &lt;elementExample id=&quot;demo&quot;&gt; ... &lt;/elementExample&gt; , tagName has the value &quot;elementExample&quot; . Note that this is case-preserving in XML, as are all of the operations of the DOM. The HTML DOM returns the tagName of an HTML element in the canonical uppercase form, regardless of the case in the source HTML document.

## Static Method Documentation

bool khtmlMalformedPrefix | ( | DOM.DOMString | name
| ) |  |  |

bool khtmlMalformedQualifiedName | ( | DOM.DOMString | name
| ) |  |  |

bool khtmlValidAttrName | ( | DOM.DOMString | name
| ) |  |  |

bool khtmlValidPrefix | ( | DOM.DOMString | name
| ) |  |  |

bool khtmlValidQualifiedName | ( | DOM.DOMString | name
| ) |  |  |